    
const querystring = require("querystring");
const http = require("http");

function ajax( method, host, port, path, data ){
    return new Promise(function( resolve, reject ){
        var post, post_data;

        let options = {
            host: host,
            port: port,
            path: path,
            method: method
        };

        if ( data ) {
            post_data = querystring.stringify(data);

            options.headers={
                'Content-Type': 'application/x-www-form-urlencoded',
                'Content-Length':Buffer.byteLength(post_data)
            };
        }

        post = http.request(options, function( ajaxResponse ) {

            let output = "";
            
            ajaxResponse.on('data', function (chunk) {
                output += chunk;
            });

            ajaxResponse.on('end', function () {
                try {
                    resolve(JSON.parse(output));
                } catch(e) {
                    reject( new Error("could not parse data."));
                }
            });
        });
            
        post.on('error', function(e) {
            reject(new Error(e.message));
        });
        
        if ( data ) {
            post.write(post_data);
        }

        post.end();
    });
}

module.exports = ajax;